#include"ll.h"

/************************************************/

ll* createLL(int data, ll* next)
{
  ll* link = (ll*)malloc(sizeof(ll));
  if (link == NULL)
    {
      printf("heap overflow...\n");
      exit(0);
    }
  link->data = data;
  link->next = next;
  return link;
}

/************************************************/

void printLL(ll* l)
{
  if (l != NULL)
    {
      printf("%d ", l->data);
      printLL(l->next);
    }
  else
    printf("\n");
}

/************************************************/

void destroyLL(ll* l)
{
  if (l != NULL)
    {
      destroyLL(l->next);
      free(l);
    }
}

/************************************************/

int xInLL(ll* l, int x)
{
  if (l == NULL)
    return 0;
  return x == l->data || xInLL(l->next, x);
}

