#ifndef LL_H
#define LL_H

#include<stdio.h>
#include<stdlib.h>

typedef struct lls
{
  int data;
  struct lls* next;
}ll;

/*
  Retourne un maillon.
*/

ll* createLL(int data, ll* next);

/*
  Affiche toute la liste.
*/

void printLL(ll* l);

/*
  Detruit toute la liste.
*/

void destroyLL(ll* l);

/*
  Retourne vrai si et seulement si x est dans la liste l.
*/

int xInLL(ll* l, int x);

#endif
