#include"genericTree.h"

/*-------------------------------------------------------------*/

void* easyMalloc(unsigned int size)
{
  void* a = malloc(size);
  if (a == NULL)
    {
      printf("easyMalloc : plus de memoire.");
      exit(1);
    }
  return a;
}

/*-------------------------------------------------------------*/

abP abMake(void* data, abP left, abP right)
{
  return NULL;
}

/*-------------------------------------------------------------*/

void* abAgregate(abP a, 
		 void* (*f)(void* data, 
			    void* leftImage, 
			    void* rightImage))
{
  return NULL;
}

/*-------------------------------------------------------------*/

abP abMap(abP a, void* (*f)(void*))
{
  return NULL;
}

/*-------------------------------------------------------------*/

void abInfixApply(abP a, void (*f)(void*))
{
}

/*-------------------------------------------------------------*/

void abDestroy(abP a, void (*destroyData)(void*))
{
}

/*-------------------------------------------------------------*/

unsigned int abHeight(abP a)
{
  return 0;
}

/*-------------------------------------------------------------*/

unsigned int abSize(abP a)
{
  return 0;
}

/*-------------------------------------------------------------*/

void abPrint(abP a, void(*print)(void*))
{
}

/*-------------------------------------------------------------*/

int puissance(int b, int n)
{
  if (n == 0)
    return 1;
  return b * puissance(b, n-1);
}

int* makeInt(int i)
{
  int* p = (int*)easyMalloc(sizeof(int));
  *p = i;
  return p;
}

abP intTree(int inf, int sup)
{
  int mid = (inf + sup)/2;
  if (inf > sup)
    return NULL;
  return abMake(makeInt(mid),
                intTree(inf, mid - 1),
                intTree(mid + 1, sup));
}

void destroyInt(void* i)
{
  free(i);
}

void printInt(void* i)
{
  printf("%d", *(int*)i);
}

int main()
{
  abP a = intTree(0, puissance(2, 5));
  abPrint(a, printInt);
  printf("\n");
  abDestroy(a, destroyInt);
  return 0;
}
