#include<stdio.h>
#include"sTree.h"

int main()
{
  sTree* t, *s = createOperatorSTree(EXP, 
				     createLnSTree(createVariableSTree()), 
				     createConstantSTree(2));
  printSTree(s);
  printf("\n%f\n", evaluateSTree(s, 6));
  t = derivateSTree(s);
  printSTree(t);
  printf("\n%f\n", integrateSTree(s, 1, 3, 5));
  destroySTree(s); 
  destroySTree(t);
  return 0;
}
